#include <zephyr.h>
#include <errno.h>
#include <stdio.h>

#include <net/socket.h>
#include <linker/sections.h>
#include <shell/shell.h>
#include <net/net_core.h>

#define MY_PORT 4242
#define PEER_PORT 4242

void main()
{
	struct sockaddr_in6 addr6, addr_peer;
	int sock_id = 0 ; 
	int ret = 0 ;  
	char msg[100] ; 

	(void)memset(&addr6, 0, sizeof(addr6));
	addr6.sin6_family = AF_INET6;
	addr6.sin6_port = htons(MY_PORT);
	inet_pton(AF_INET6, CONFIG_NET_CONFIG_MY_IPV6_ADDR,
			  &addr6.sin6_addr);
	sock_id = socket(AF_INET6, SOCK_DGRAM, IPPROTO_UDP);
	if(sock_id == -1)
	{
		printk("Error in creating socket \n") ; 
		return ; 
	}
	
	ret = bind(sock_id, (struct sockaddr *) &addr6, sizeof(addr6)) ;
        addr_peer.sin6_family = AF_INET6;
        addr_peer.sin6_port = htons(PEER_PORT);
        inet_pton(AF_INET6, CONFIG_NET_CONFIG_PEER_IPV6_ADDR,
                  &addr_peer.sin6_addr);
	
	while(true)
	{ 
		/* Continously send message to a server after every 5 seconds */
		ret = recv(sock_id, (void*) msg, sizeof(msg), 0) ; 
		if(ret < 0)
		{
			printk("Error in Receiving a Message \n"); 
			return ; 
		}
		else
		{
			printk("%s\n", msg) ; 
			ret = sendto(sock_id, msg, sizeof(msg), 0, (struct sockaddr *)&addr_peer, sizeof(addr_peer)) ;
			if(ret < 0 )
			{
					printk("Error in transmitting message \n") ; 
			}
		}
	}
	close(sock_id) ; 
	return ; 
}